unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, Spin, Menus, IniFiles;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    PopupMenu1: TPopupMenu;
    About1: TMenuItem;
    Exit1: TMenuItem;
    More: TSpeedButton;
    Less: TSpeedButton;
    Edit4: TEdit;
    Edit5: TEdit;
    Label3: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Panel1: TPanel;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MoreClick(Sender: TObject);
    procedure LessClick(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
implementation



{$R *.dfm}
//   DLL
function Sum(a,b: real): real;
external 'action.dll';

function Substract(c,d: real): real;
external 'action.dll';

function Mult(e,f: real): real;
external 'action.dll';

function Divide(x,y: real): real;
external 'action.dll';

function Procent(g,h: real): real;
external 'action.dll';

function Square(a: real): real;
external 'MathActions.dll';

function Root(b: real): real;
external 'MathActions.dll';

function Absolut(c: real): real;
external 'MathActions.dll';

function Sinus(d: real): real;
external 'MathActions.dll';

function Cosinus(e: real): real;
external 'MathActions.dll';

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
try
Edit3.Text:=FloatToStr(Sum(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
except
Beep;
Edit3.Text:='Error';
end;
end;

// 
procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
try
Edit3.Text:=FloatToStr(Substract(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
except
Beep;
Edit3.Text:='Error';
end;
end;

// 
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
try
Edit3.Text:=FloatToStr(Mult(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
except
Beep;
Edit3.Text:='Error';
end;
end;

// 
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
try
Edit3.Text:=FloatToStr(Divide(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
except
Beep;
Edit3.Text:='Error';
end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Form1.Height:=128;
end;

procedure TForm1.MoreClick(Sender: TObject);
begin
More.Visible:=False;
Less.Visible:=True;
Panel1.Visible:=True;
Edit4.Visible:=true;
Edit5.Visible:=true;
Label3.Visible:=true;
SpeedButton7.Visible:=true;
SpeedButton8.Visible:=true;
SpeedButton9.Visible:=true;
SpeedButton10.Visible:=true;
Form1.Height:=208;
end;

procedure TForm1.LessClick(Sender: TObject);
begin
More.Visible:=True;
Less.Visible:=False;
Panel1.Visible:=false;
Edit4.Visible:=false;
Edit5.Visible:=false;
Label3.Visible:=false;
SpeedButton7.Visible:=false;
SpeedButton8.Visible:=false;
SpeedButton9.Visible:=false;
SpeedButton10.Visible:=false;
Form1.Height:=128;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
try
Edit5.Text:=FloatToStr(Square(StrToFloat(Edit4.Text)));
except
Beep;
Edit5.Text:='Error';
end;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
try
Edit5.Text:=FloatToStr(Root(StrToInt(Edit4.Text)));
except
Beep;
Edit5.Text:='Error';
end;
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
try
Edit5.Text:=FloatToStr(Absolut(StrToInt(Edit4.Text)));
except
Beep;
Edit5.Text:='Error';
end;
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
try
Edit5.Text:=FloatToStr(Sinus(StrToInt(Edit4.Text)));
except
Beep;
Edit5.Text:='Error';
end;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in [#8,'0'..'9',',']) then Key := #0;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in [#8,'0'..'9',',']) then Key := #0;
end;

procedure TForm1.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in [#8,'0'..'9',',']) then Key := #0;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
try
Edit3.Text:= FloatToStr(Procent(StrToFloat(Edit1.Text), StrToFloat(Edit2.Text)));
except
Beep;
Edit3.Text:='Error';
end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
try
Edit5.Text:=FloatToStr(Cosinus(StrToInt(Edit4.Text)));
except
Beep;
Edit5.Text:='Error';
end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var Config: TIniFile;
begin
try
Config:=TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Config.ini');
Config.WriteInteger('FORM', 'Height',Form1.Height);
Config.WriteString('VALUE', 'Edit1', Edit1.Text);
Config.WriteString('VALUE', 'Edit2', Edit2.Text);
Config.WriteString('VALUE', 'Edit4', Edit4.Text);
except
Form1.Free;
end;
end;

end.
